/**
 * PDNumberLabelPanel.java
 *
 * An example Observer for the Pattern Demo.
 * 
 * @author  Jeff Ondich
 * @version 2.0.0
 * date:    2013.11.12
 */

import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;

public class PDNumberLabelPanel extends PDPanel
                                implements PDObserver {
    private JLabel numberLabel;
    private int numberType;
    private PDNumberStrategy numberStrategy;

    public PDNumberLabelPanel() {
    	this.numberStrategy = new PDArabicNumberStrategy();

        this.numberLabel = new JLabel("", SwingConstants.CENTER);
        this.numberLabel.setFont(this.numberLabel.getFont().deriveFont(64.0f));
        this.numberLabel.setForeground(Color.white);

        this.setLayout(new GridLayout());
        this.add(this.numberLabel);
        this.setBackground(new Color(80, 30, 30));
    }
    
    public void setNumberStrategy(PDNumberStrategy strategy) {
    	this.numberStrategy = strategy;
    }

    // PDPanel abstract methods.
    public void applyCachedValue() {
        String text = this.numberStrategy.getNumberString(this.cachedValue);
        this.numberLabel.setText(text);
    }

    public void update(PDSubject subject) {
        this.cachedValue = subject.getValue();
        this.applyCachedValue();
    }
}

